<script lang="ts">
import Vue from 'vue';
import { AosAnimationsMixin, LocalizedHrefMixin } from '../mixins';
import SlpNavigationHOC from '../components/navigation/navigation-hoc.vue';
import SlpFooterHOC from '~/components/navigation/footer-hoc.vue';
import { generateLayoutMeta } from '~/common/meta';
import { MetaInfo } from 'vue-meta/types/vue-meta';

export default Vue.extend({
  components: {
    SlpFooterHOC,
    SlpNavigationHOC,
  },
  mixins: [LocalizedHrefMixin, AosAnimationsMixin],
  data() {
    return {
      footer: {},
      contentfulEntryUrl: '',
    };
  },
  head(): MetaInfo {
    return generateLayoutMeta(this.$route.path, this.$i18n.locale);
  },
  created() {
    this.$nuxt.$on('contentfulIds', (data) => {
      const { spaceId, entryId } = data;
      if (spaceId !== undefined && entryId !== undefined) {
        this.contentfulEntryUrl = `https://app.contentful.com/spaces/${spaceId}/entries/${entryId}`;
      }
    });
  },
  beforeMount() {
    this.validateIndexFiles();
  },
  methods: {
    validateIndexFiles() {
      if (this.$route.path.endsWith('index.html')) {
        const queryParams = this.$route.query;
        const oldPath = this.$route.path.replace(/(\W*index\.html\W*)/g, '');
        this.$router.replace({
          path: `${oldPath}/`,
          query: queryParams,
        });
      }
    },
  },
});
</script>

<template>
  <div>
    <SlpNavigationHOC />
    <section ref="localizedContainer">
      <Nuxt role="main" />
    </section>
    <SlpFooterHOC :contentful-entry-id="contentfulEntryUrl" />
  </div>
</template>
